package com.qa.stepdefinition;

import static org.hamcrest.CoreMatchers.containsString;
import static org.hamcrest.CoreMatchers.notNullValue;

import java.io.File;

import com.qa.utilities.Util;

import cucumber.api.java.en.Then;
import cucumber.api.java.en.When;
import io.restassured.RestAssured;
import io.restassured.response.Response;
import io.restassured.response.ValidatableResponse;

public class Employee_post_steps {
	private Response response;
	private ValidatableResponse json;
	private Util util =new Util();
	@When("^employee data is uploaded through webservice$")
	public void employee_data_is_uploaded_through_webservice() throws Throwable {
		//File reqPayload = util.convertJsonFiletoFile("src/test/resources/requestPayload_employee/employee_post_req_payload.json");
		File reqPayload = new File(util.getValue("employee_correct_req_payload_loc"));
		
	    response = util.post_employee(reqPayload);
	   
	}

	@Then("^verify the success status code (\\d+)$")
	public void verify_the_success_status_code(int arg1) throws Throwable {
		//Assertion for status code and initializing jsonresponse varialble
	    json = response.then().statusCode(arg1);
	}

	@Then("^verify employee_id is generated$")
	public void verify_employee_id_is_generated() throws Throwable {
		//Assertion to check employeeid present and not null value in response json hgfjbkjn
		json.body(containsString("id"), notNullValue());
	}

	@When("^wrong employee data is uploaded through webservice$")
	public void wrong_employee_data_is_uploaded_through_webservice() throws Throwable {
		File reqPayload = util.convertJsonFiletoFile(util.getValue("employee_wrong_req_payload_loc"));
		response = util.post_employee(reqPayload);
	    
	}

	@Then("^verify error message is generated$")
	public void verify_error_message_is_generated() throws Throwable {
		//Assertion to check error message in response
		 //json.body(containsString("Integrity constraint violation"));
	    
	}

}